<template>
  <transition name="opacity">
    <div>
      <div class="h-screen" style="display: grid; grid-template: 'content' 1fr 'footer' auto / auto">
        <div
          class="md:my-8 bg-white md:rounded-lg md:shadow-lg container mx-auto lg:max-w-2/3 md:self-center"
          style="grid-area: content"
        >
          <div class="absolute top-0 right-0 z-0" style="z-index: -10">
            <img src="img/logo-bg.svg" class="w-1/3 opacity-50 m-8 float-right" />
          </div>
          <div class="font-bold flex flex-row items-center justify-start p-8 pt-16 md:pt-10">
            <img src="img/logo.svg" class="h-6 mr-4" />
            Todoninja
          </div>
          <div class="m-8 font-bold text-3xl">
            Welcome!
            <div class="text-gray-600 text-base font-normal mt-4">
              Let's get you started by creating an account.
            </div>
          </div>

          <error-hint :error="error" class="m-4"></error-hint>

          <form @submit.prevent="submitForm()">
            <inputt
              name="Full Name"
              classes="pb-2 mx-8"
              placeholder="John Doe"
              type="name"
              :value="name"
              @input="name = $event"
            ></inputt>
            <inputt
              name="Email"
              classes="pb-2 mx-8"
              placeholder="john.doe@domain.com"
              type="email"
              :value="username"
              @input="username = $event"
            ></inputt>
            <inputt
              classes="pb-2 mx-8"
              name="Password"
              placeholder="********"
              type="password"
              :value="password"
              @input="password = $event"
            ></inputt>
            <button type="submit" class="button m-8">
              Register
            </button>
          </form>
        </div>

        <div class="bg-blueGray-200 py-16 flex flex-row items-center justify-center self-end" style="grid-area: footer">
          You already have an account?
          <router-link class="ml-4 link" to="/login">Login</router-link>
        </div>
      </div>
    </div>
  </transition>
</template>

<script lang="ts">
import Inputt from "@/components/Inputt.vue";
import router from "@/router";
import User from "@/models/User";
import ErrorHint from "@/components/Error.vue";
import { ref } from "@vue/reactivity";
import { Auth } from "@/assets/Auth";
import Message from "@/models/Message";

export default {
  components: { Inputt, ErrorHint },
  setup() {
    const name = ref("");
    const username = ref("");
    const password = ref("");
    const error = ref<undefined | {}>(undefined);

    const submitForm = async () => {
      try {
        const user = await User.create({
          email: username.value,
          password: password.value,
          name: name.value
        });
        await Auth.login({ username: username.value, password: password.value }).then(() => router.push("/"));
      } catch (e) {
        Message.error({ title: e.message }).save();
      }
    };

    return {
      name,
      username,
      password,
      submitForm,
      error
    };
  }
};
</script>
